/*
      SoundMan v0.1 - Realtime frequency analyzer
      Copyright (C) 1999 Gabor Kerenyi (wom@fireball.kalmar.hu)
*/

/**********************************************************************

	--- Qt Architect generated file ---

	File: mainwin.cpp
	Last generated: Sun Nov 29 17:18:01 1998

 *********************************************************************/

#include "mainwin.h"
#include <math.h>
#include "devconfig.h"
#include <qscrollbar.h>
#include <qstatusbar.h>
#include <qprogressbar.h>
#include <qmessagebox.h>
//#include "main.h"
#include <stdio.h>
#include <unistd.h>
#include <sys/soundcard.h>
#include <fcntl.h>
#include <stdlib.h>
#include <qlabel.h>
#include <qframe.h>
#include "fft.h"
#include <qtimer.h>
#include "spgram.h"
#include "filter.h"
#include "nfilter.h"
#include "player.h"
#include <qprogressdialog.h>
#include "chcolor.h"
#include "qpainter.h"
#include <qapplication.h>

#define Inherited mainwinData


extern cnf mconf;
QTimer *timer=new QTimer();
int real_f;

QStatusBar *stbar;
Fft *fftv;
int realt;
bool wdisp=TRUE,sdisp=TRUE;

mainwin::mainwin
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "FFT Main Window" );
	stbar=new QStatusBar(this,0);
	stbar->show();
	mconf.wave.zoomx=1;
	xmag_wave_lcd->display(1);
        realt=0;
	mconf.col.ampl_background.r=0;
	mconf.col.ampl_background.g=0;
	mconf.col.ampl_background.b=0;
	mconf.col.sgr_background.r=0;
	mconf.col.sgr_background.g=0;
	mconf.col.sgr_background.b=0;
	mconf.col.wave_background.r=0;
	mconf.col.wave_background.b=0;
	mconf.col.wave_background.g=0;
 	freqlab->hide();
  	plab->hide();
  	cb_freq->hide();
  	cb_p->hide();
  	bon->hide();
  	bok->hide();
	bon->toggle();
	bok->toggle();
	bres->hide();
	xyarr->toggle();
	loadcf();
	wd->setBackgroundColor(QColor(mconf.col.wave_background.r,mconf.col.wave_background.g,mconf.col.wave_background.b));
	fd->setBackgroundColor(QColor(mconf.col.ampl_background.r,mconf.col.ampl_background.g,mconf.col.ampl_background.b));
	strcpy(mconf.dev.dev,"/dev/dsp");
}

void mainwin::loadcf()
{
  char c[256];
  int f;

  strcpy(c,mconf.home);
  f=open(strcat(c,"/soundman.conf"),O_RDONLY);
  if (f>0)
  {
     read(f,&mconf.col,sizeof(colors));
     file_close(f);
  }
  else
  {
     mkdir(mconf.home,0777);
  }
}

void mainwin::agc(bool i)
{
  mconf.spect.agc=i;
}

void mainwin::xyarrangers(bool i)
{
   mconf.spect.xyarrangers=i;
   fd->update();
}

void mainwin::wave_display(bool i)
{
  wdisp=i;
}

void mainwin::spect_display(bool i)
{
  sdisp=i;
}

void mainwin::colsetup()
{
  chcolor ch;

  ch.show();
  fd->setBackgroundColor(QColor(mconf.col.ampl_background.r,mconf.col.ampl_background.g,mconf.col.ampl_background.b));
  wd->setBackgroundColor(QColor(mconf.col.wave_background.r,mconf.col.wave_background.g,mconf.col.wave_background.b));
}

void mainwin::resizeEvent(QResizeEvent *p)
{
int w=width();
int h=height()-10;

frame0->resize(w-215,h/2-15);
wd->resize(w-225,h/2-40);
frame1->resize(w-215,h/2-30);
fd->resize(w-225,h/2-40);
fd->move(20,h/2+20);
frame1->move(15,h/2+15);
scbar->resize(w-225,15);
scbar->move(20,h/2-25);
hline->resize(w-15,10);
hline->move(10,h/2);
xlab->move(w-195,15);
wlen->move(w-195,45);
freqlab->move(w-195,85);
plab->move(w-195,115);
bxm->move(w-115,15);
len_wave_lcd->move(w-115,50);
cb_freq->move(w-115,85);
cb_p->move(w-115,115);
xmag_wave_lcd->move(w-85,15);
bxp->move(w-45,15);
l1->move(w-45,50);
l2->move(w-45,h/2-30);
wlab->move(w-195,h/2-30);
start_wave_lcd->move(w-115,h/2-30);
xyarr->move(w-195,h/2+135);
bon->move(w-115,145);
xtlab->move(w-195,h/2+15);
ytlab->move(w-195,h/2+45);
wflab->move(w-195,h/2+75);
slab->move(w-195,h/2+105);
cb_x->move(w-115,h/2+15);
cb_y->move(w-115,h/2+45);
cb_win->move(w-115,h/2+75);
cb_agc->move(w-70,h/2+135);
cb_fv->move(w-115,h/2+105);
bok->move(w-195,h-45);
bres->move(w-115,h-45);
}

void mainwin::recnoise()
{
   int f=open(mconf.dev.dev,O_RDONLY);
   int freq;
   char info[256];

   if (f<1){
        strcpy(info,"Cannot open device:\n");
	strcat(info,mconf.dev.dev);
        strcat(info," it's possible that another program uses it!\n");
	QMessageBox::warning(this,"FFT Maker",info);
   }
   else {
	int old_window=mconf.spect.window;
	int i;

	mconf.wnoise=(unsigned char *)malloc(8192);
	if (mconf.noise==NULL)
	   mconf.noise=(float *)calloc(8192,sizeof(float));
	freq=mconf.dev.freq;
        ioctl(f,SNDCTL_DSP_SPEED,&freq);
        read(f,(mconf.wnoise),8192);
	file_close(f);	
	if (mconf.spect.source!=NULL)
	   free(mconf.spect.source);
	mconf.spect.source=(complex *)calloc(8192,sizeof(complex));
	mconf.spect.window=0;
	Fft fft;
	fft.init(13);
	fft.cp_datas(0,8191,mconf.wnoise);
	fft.fft();
	fft.close();
	mconf.spect.window=old_window;
	for (i=0;i<8192;i++)
	{
 	   *(mconf.noise+i)=*(mconf.spect.power+i);
	}
   	free(mconf.wnoise);
   }
}

void mainwin::config_dev()
{
  devconfig dvc;
  dvc.show();
}

void mainwin::noise_filtering()
{
if (mconf.wave.wave!=NULL)
{
  nfilter nf;
  nf.show();
}
}

void mainwin::linlogx(int i)
{
  mconf.spect.displayx=i;
  fd->update();
}

void mainwin::linlogy(int i)
{
  mconf.spect.displayy=i;
  fd->update();
}

void mainwin::window_ch(int i)
{
  mconf.spect.window=i;
}

void mainwin::display_ch(int i)
{
  mconf.spect.display=i;
  fd->update(); 
}

void mainwin::play()
{
if (mconf.wave.wave!=NULL)
{
  player pl;
  pl.show();
}
}

void mainwin::reinit_scbar()
{
int tmp;

 mconf.wave.window_length_pn=mconf.wave.rec_pn/mconf.wave.zoomx;
 mconf.wave.window_length=(int)(((float)mconf.wave.rec_pn/(float)mconf.wave.zoomx)/(float)mconf.wave.freq)*100;
 xmag_wave_lcd->display(mconf.wave.zoomx);
 len_wave_lcd->display(mconf.wave.window_length);
// if (mconf.wave.window_start_pn+mconf.wave.window_length_pn>mconf.wave.rec_pn) mconf.wave.window_start=0;
 scbar->close();
 tmp=(int)(((float)mconf.dev.rec_pn/(float)mconf.dev.freq)*100)-mconf.wave.window_length;
 scbar=new QScrollBar(0,tmp,1,tmp/10,0,QScrollBar::Horizontal,this);
 scbar->resize(width()-225,15);
 scbar->move(20,(height()-10)/2-25);
 scbar->show();
 mconf.wave.window_start=0;
 mconf.wave.window_start_pn=0;
 connect(scbar,SIGNAL(valueChanged(int)),SLOT(start_changed(int)));
 wd->update();
}


void mainwin::start_changed(int a)
{
  start_wave_lcd->display(a);
  mconf.wave.window_start_pn=a*mconf.wave.freq/100;
  mconf.wave.window_start=a;
  wd->update();
}

void mainwin::inc_wave_x()
{
  mconf.wave.zoomx++;
  reinit_scbar();
}

void mainwin::dec_wave_x()
{
if (mconf.wave.zoomx>1){
  mconf.wave.zoomx--;
  reinit_scbar();
}
}

void mainwin::spgr()
{
if (mconf.wave.wave!=NULL)
{
  spgram sp;
  sp.exec();
  sp.start_fft();
}
}

void mainwin::f_filter()
{
if (mconf.wave.wave!=NULL)
{
  filter f;
  f.exec();
}
}

void mainwin::fft()
{
if (mconf.wave.wave!=NULL)
{
  int logn;
  int to,from;
  int len;
  int pn;
  Fft f;

  from=mconf.wave.window_start_pn;
  len=mconf.wave.window_length_pn;
  logn=(int)(log((float)len)/log((float)2));
  pn=1<<logn;
  to=mconf.wave.window_start_pn+pn;
  //if (mconf.spect.source!=NULL) free(mconf.spect.source);
  mconf.spect.source=(complex *)calloc(pn,sizeof(complex));
  mconf.spect.pn=pn;
  f.init(logn);
  f.cp_datas(from,to,mconf.wave.wave);
  f.fft();
  f.close();   
  free(mconf.spect.source);
  fd->update();
}
}

void mainwin::realtime()
{
int i;
if (realt==0){
  freqlab->show();
  plab->show();
  cb_freq->show();
  cb_p->show();
  bon->show();
  bok->show();
  bres->show();
  if (mconf.wave.wave!=NULL)
     free(mconf.wave.wave);
  mconf.wave.rec_pn=512;
  mconf.dev.rec_pn=512;
  mconf.wave.wave=(unsigned char *)malloc(mconf.wave.rec_pn);
  mconf.wave.freq=11025;
  mconf.dev.freq=11025;
  mconf.spect.abs_maxpower=0;
  real_f=open(mconf.dev.dev,O_RDONLY);
  i=mconf.wave.freq;
  ioctl(real_f,SNDCTL_DSP_SPEED,&i);
  reinit_scbar();
  if (mconf.spect.source!=NULL)
     free(mconf.spect.source);
  mconf.spect.source=(complex *)calloc(mconf.wave.rec_pn,sizeof(complex));
  mconf.spect.pn=mconf.wave.rec_pn;
  fftv=new Fft();
  fftv->init(9);
  connect(timer,SIGNAL(timeout()),SLOT(read_data()));
  realt=1;
  timer->start(0,FALSE);
}
else {
  freqlab->hide();
  plab->hide();
  cb_freq->hide();
  cb_p->hide();
  bon->hide();
  bok->hide();
  bres->hide();
  timer->stop();
  fftv->close();
  file_close(real_f);
  realt=0;
}
}

void mainwin::rec_pn_changed(const char *c)
{
int a;

mconf.wave.rec_pn=atoi(c);
if (mconf.wave.wave!=NULL)
   free(mconf.wave.wave);
mconf.wave.wave=(unsigned char *)malloc(mconf.wave.rec_pn);
if (mconf.spect.source!=NULL)
   free(mconf.spect.source);
mconf.spect.source=(complex *)calloc(mconf.wave.rec_pn,sizeof(complex));
mconf.spect.pn=mconf.wave.rec_pn;
a=(int)(log(mconf.wave.rec_pn)/log(2));
fftv->init(a);
reinit_scbar();
}

void mainwin::freq_changed(const char *c)
{
int a;

mconf.wave.freq=atoi(c);
a=mconf.wave.freq;
file_close(real_f);
real_f=open(mconf.dev.dev,O_RDONLY);
ioctl(real_f,SNDCTL_DSP_SPEED,&a);
reinit_scbar();
}

void mainwin::resety()
{
  mconf.spect.abs_maxpower=0;
}

void mainwin::read_data()
{
int i;

if (mconf.wave.rec_pn>4096) 
{
  memcpy(mconf.wave.wave,mconf.wave.wave+4096,mconf.wave.rec_pn-4096);
  read(real_f,mconf.wave.wave+mconf.wave.rec_pn-4096,4096);
}
else
{
  read(real_f,mconf.wave.wave,mconf.wave.rec_pn);
}
for (i=0;i<mconf.wave.rec_pn;i++)
{
  (mconf.spect.source+i)->re=*(mconf.wave.wave+i);
  (mconf.spect.source+i)->im=0;  
}
  if (wdisp)
     wd->repaint(TRUE);
  fftv->fft();
  if (!mconf.spect.agc)
     if (mconf.spect.abs_maxpower<mconf.spect.maxpower)
        mconf.spect.abs_maxpower=mconf.spect.maxpower;
     else {
        mconf.spect.maxpower=mconf.spect.abs_maxpower;
        mconf.spect.abs_maxpower*=0.993;
     }
  if (sdisp) fd->repaint(TRUE);
}

void mainwin::record()
{
int f;
int freq;
char info[256];
long mpbar;
long mmp;

f=open(mconf.dev.dev,O_RDONLY);
if (f<1){
    strcpy(info,"Cannot open device:\n");
    strcat(info,mconf.dev.dev);
    strcat(info," It's possible that another program uses it!\n");
    QMessageBox::warning(this,"FFT Maker",info);
   }
else {
    long reced=0;
    QProgressDialog pbar("Recording sound","Stop",100,this);

    pbar.show();
    freq=mconf.dev.freq;
    ioctl(f,SNDCTL_DSP_SPEED,&freq);
    if (mconf.dev.rec_pn>0){
	mconf.dev.ido=mconf.dev.rec_pn/mconf.dev.freq;
    }
    if (mconf.wave.wave!=NULL)
	free(mconf.wave.wave);
    mconf.wave.wave=(unsigned char *)malloc(mconf.dev.rec_pn+8192);
    while (reced<mconf.dev.rec_pn){
        read(f,(mconf.wave.wave+reced),8192);
        mpbar=(int)(((float)reced/(float)mconf.dev.rec_pn)*100);
	mmp=(int)((float)reced/(float)mconf.dev.freq);
	pbar.setProgress(mpbar);
	qApp->processEvents(2);
	reced+=8192;
    }
    mconf.dev.rec_pn=reced;
    file_close(f);	

    mconf.wave.rec_pn=reced;
    mconf.wave.freq=mconf.dev.freq;
    mconf.wave.ido=mconf.wave.rec_pn/mconf.wave.freq;  
    reinit_scbar();
    pbar.close();
   }
}

mainwin::~mainwin()
{
}
